<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>frontend documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">frontend documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content component">
                   <div class="content-data">




<ol class="breadcrumb">
  <li>Components</li>
  <li>VotingSiteConfigurationComponent</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
        <li >
            <a href="#templateData" role="tab" id="templateData-tab" data-toggle="tab" data-link="template">Template</a>
        </li>
        <li >
            <a href="#styleData" role="tab" id="styleData-tab" data-toggle="tab" data-link="style">Styles</a>
        </li>
        <li >
            <a href="#tree" role="tab" id="tree-tab" data-toggle="tab" data-link="dom-tree">DOM Tree</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info"><p class="comment">
    <h3>File</h3>
</p>
<p class="comment">
    <code>src/app/operation/parameters/voting-site-configuration/edit/voting-site-configuration.component.ts</code>
</p>



    <p class="comment">
        <h3>Implements</h3>
    </p>
    <p class="comment">
                <code><a href="https://angular.io/api/core/OnInit" target="_blank" >OnInit</a></code>
                <code><a href="../interfaces/ConfirmBeforeQuit.html" target="_self" >ConfirmBeforeQuit</a></code>
                <code><a href="https://angular.io/api/core/OnDestroy" target="_blank" >OnDestroy</a></code>
    </p>


<section>
    <h3>Metadata</h3>
    <table class="table table-sm table-hover">
        <tbody>











            <tr>
                <td class="col-md-3">selector</td>
                <td class="col-md-9"><code>voting-site-configuration-edit</code></td>
            </tr>

            <tr>
                <td class="col-md-3">styleUrls</td>
                <td class="col-md-9"><code>./voting-site-configuration.component.scss</code></td>
            </tr>



            <tr>
                <td class="col-md-3">templateUrl</td>
                <td class="col-md-9"><code>./voting-site-configuration.component.html</code></td>
            </tr>








        </tbody>
    </table>
</section>

    <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
                <tr>
                    <td class="col-md-4">
                        <h6><b>Properties</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#config">config</a>
                            </li>
                            <li>
                                <a href="#form">form</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#operation">operation</a>
                            </li>
                            <li>
                                <a href="#readOnly">readOnly</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#saved">saved</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#subscriptions">subscriptions</a>
                            </li>
                        </ul>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#changeDefaultLang">changeDefaultLang</a>
                            </li>
                            <li>
                                <a href="#isFormModified">isFormModified</a>
                            </li>
                            <li>
                                <a href="#ngOnDestroy">ngOnDestroy</a>
                            </li>
                            <li>
                                <a href="#ngOnInit">ngOnInit</a>
                            </li>
                            <li>
                                <a href="#save">save</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#updateForReadonly">updateForReadonly</a>
                            </li>
                        </ul>
                    </td>
                </tr>





                    <tr>
                        <td class="col-md-4">
                            <h6><b>Accessors</b></h6>
                        </td>
                    </tr>
                    <tr>
                        <td class="col-md-4">
                            <ul class="index-list">
                                <li>
                                    <a href="#ready">ready</a>
                                </li>
                                <li>
                                    <a href="#allPossibleLanguages">allPossibleLanguages</a>
                                </li>
                            </ul>
                        </td>
                    </tr>
        </tbody>
    </table>
</section>

    <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(service: <a href="../injectables/VotingSiteConfigurationService.html">VotingSiteConfigurationService</a>, formBuilder: <a href="https://angular.io/api/forms/FormBuilder" target="_blank">FormBuilder</a>, router: <a href="https://angular.io/api/router/Router" target="_blank">Router</a>, route: <a href="https://angular.io/api/router/ActivatedRoute" target="_blank">ActivatedRoute</a>, dictionaryService: <a href="../injectables/DictionaryService.html">DictionaryService</a>, readOnlyService: <a href="../injectables/ReadOnlyService.html">ReadOnlyService</a>, operationManagementService: <a href="../injectables/OperationManagementService.html">OperationManagementService</a>)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="29" class="link-to-prism">src/app/operation/parameters/voting-site-configuration/edit/voting-site-configuration.component.ts:29</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>service</td>
                                                  
                                                        <td>
                                                                    <code><a href="../injectables/VotingSiteConfigurationService.html" target="_self" >VotingSiteConfigurationService</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>formBuilder</td>
                                                  
                                                        <td>
                                                                    <code><a href="https://angular.io/api/forms/FormBuilder" target="_blank" >FormBuilder</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>router</td>
                                                  
                                                        <td>
                                                                    <code><a href="https://angular.io/api/router/Router" target="_blank" >Router</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>route</td>
                                                  
                                                        <td>
                                                                    <code><a href="https://angular.io/api/router/ActivatedRoute" target="_blank" >ActivatedRoute</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>dictionaryService</td>
                                                  
                                                        <td>
                                                                    <code><a href="../injectables/DictionaryService.html" target="_self" >DictionaryService</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>readOnlyService</td>
                                                  
                                                        <td>
                                                                    <code><a href="../injectables/ReadOnlyService.html" target="_self" >ReadOnlyService</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>operationManagementService</td>
                                                  
                                                        <td>
                                                                    <code><a href="../injectables/OperationManagementService.html" target="_self" >OperationManagementService</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>





    <section>
    
        <h3 id="methods">
            Methods
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="changeDefaultLang"></a>
                        <span class="name">
                            <b>
                            changeDefaultLang
                            </b>
                            <a href="#changeDefaultLang"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>changeDefaultLang()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="109" class="link-to-prism">src/app/operation/parameters/voting-site-configuration/edit/voting-site-configuration.component.ts:109</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="isFormModified"></a>
                        <span class="name">
                            <b>
                            isFormModified
                            </b>
                            <a href="#isFormModified"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>isFormModified()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="50" class="link-to-prism">src/app/operation/parameters/voting-site-configuration/edit/voting-site-configuration.component.ts:50</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/boolean" target="_blank" >boolean</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="ngOnDestroy"></a>
                        <span class="name">
                            <b>
                            ngOnDestroy
                            </b>
                            <a href="#ngOnDestroy"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>ngOnDestroy()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="121" class="link-to-prism">src/app/operation/parameters/voting-site-configuration/edit/voting-site-configuration.component.ts:121</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="ngOnInit"></a>
                        <span class="name">
                            <b>
                            ngOnInit
                            </b>
                            <a href="#ngOnInit"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>ngOnInit()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="54" class="link-to-prism">src/app/operation/parameters/voting-site-configuration/edit/voting-site-configuration.component.ts:54</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="save"></a>
                        <span class="name">
                            <b>
                            save
                            </b>
                            <a href="#save"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>save()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="89" class="link-to-prism">src/app/operation/parameters/voting-site-configuration/edit/voting-site-configuration.component.ts:89</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="updateForReadonly"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            updateForReadonly
                            </b>
                            <a href="#updateForReadonly"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                            <span class="modifier-icon icon ion-ios-reset"></span>
                        <code>updateForReadonly()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="114" class="link-to-prism">src/app/operation/parameters/voting-site-configuration/edit/voting-site-configuration.component.ts:114</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>

    <section>
    
        <h3 id="inputs">
            Properties
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="config"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            config
                            </b>
                            <a href="#config"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>config:     <code><a href="../interfaces/VotingSiteConfiguration.html" target="_self" >VotingSiteConfiguration</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="../interfaces/VotingSiteConfiguration.html" target="_self" >VotingSiteConfiguration</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="28" class="link-to-prism">src/app/operation/parameters/voting-site-configuration/edit/voting-site-configuration.component.ts:28</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="form"></a>
                        <span class="name">
                            <b>
                            form
                            </b>
                            <a href="#form"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <code>form:     <code><a href="https://angular.io/api/forms/FormGroup" target="_blank" >FormGroup</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="https://angular.io/api/forms/FormGroup" target="_blank" >FormGroup</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="23" class="link-to-prism">src/app/operation/parameters/voting-site-configuration/edit/voting-site-configuration.component.ts:23</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="operation"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            operation
                            </b>
                            <a href="#operation"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>operation:     <code><a href="../classes/Operation.html" target="_self" >Operation</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="../classes/Operation.html" target="_self" >Operation</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="27" class="link-to-prism">src/app/operation/parameters/voting-site-configuration/edit/voting-site-configuration.component.ts:27</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="readOnly"></a>
                        <span class="name">
                            <b>
                            readOnly
                            </b>
                            <a href="#readOnly"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <code>readOnly:     <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/boolean" target="_blank" >boolean</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/boolean" target="_blank" >boolean</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="24" class="link-to-prism">src/app/operation/parameters/voting-site-configuration/edit/voting-site-configuration.component.ts:24</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="saved"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            saved
                            </b>
                            <a href="#saved"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>saved:     <code></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>false</code>
                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="26" class="link-to-prism">src/app/operation/parameters/voting-site-configuration/edit/voting-site-configuration.component.ts:26</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="subscriptions"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            subscriptions
                            </b>
                            <a href="#subscriptions"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>subscriptions:     <code>Subscription[]</code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code>Subscription[]</code>

                        </td>
                    </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Default value : </i><code>[]</code>
                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="29" class="link-to-prism">src/app/operation/parameters/voting-site-configuration/edit/voting-site-configuration.component.ts:29</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
</section>

    <section>
    <h3 id="accessors">
        Accessors
    </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="ready"></a>
                        <span class="name"><b>ready</b><a href="#ready"><span class="icon ion-ios-link"></span></a></span>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <span class="accessor"><b>get</b><code>ready()</code></span>
                    </td>
                </tr>
                            <tr>
                                <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="42" class="link-to-prism">src/app/operation/parameters/voting-site-configuration/edit/voting-site-configuration.component.ts:42</a></div>
                                </td>
                            </tr>

            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="allPossibleLanguages"></a>
                        <span class="name"><b>allPossibleLanguages</b><a href="#allPossibleLanguages"><span class="icon ion-ios-link"></span></a></span>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <span class="accessor"><b>get</b><code>allPossibleLanguages()</code></span>
                    </td>
                </tr>
                            <tr>
                                <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="46" class="link-to-prism">src/app/operation/parameters/voting-site-configuration/edit/voting-site-configuration.component.ts:46</a></div>
                                </td>
                            </tr>

            </tbody>
        </table>
</section>
</div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Component, OnDestroy, OnInit } from &#x27;@angular/core&#x27;;
import { VotingSiteConfigurationService } from &#x27;../voting-site-configuration.service&#x27;;
import { ConfirmBeforeQuit } from &#x27;../../../../core/confirm-before-quit&#x27;;
import { FormBuilder, FormGroup, Validators } from &#x27;@angular/forms&#x27;;
import { ActivatedRoute, Router } from &#x27;@angular/router&#x27;;
import { OperationManagementService } from &#x27;../../../service/operation-managment.service&#x27;;
import { enableFormComponent, enableFormComponents, isFormModifiedAndNotSaved } from &#x27;../../../../core/util/form-utils&#x27;;
import { Operation } from &#x27;../../../model/operation&#x27;;
import { flatMap, map, tap } from &#x27;rxjs/operators&#x27;;
import { of } from &#x27;rxjs/observable/of&#x27;;
import { VotingSiteConfiguration } from &#x27;../voting-site-configuration&#x27;;
import { DictionaryService } from &#x27;../../../../core/service/dictionary.service&#x27;;
import { ReadOnlyService } from &#x27;../../../service/read-only.service&#x27;;
import { Subscription } from &#x27;rxjs/Subscription&#x27;;

@Component({
  selector: &#x27;voting-site-configuration-edit&#x27;,
  templateUrl: &#x27;./voting-site-configuration.component.html&#x27;,
  styleUrls: [&#x27;./voting-site-configuration.component.scss&#x27;]
})
export class VotingSiteConfigurationComponent implements OnInit, ConfirmBeforeQuit, OnDestroy {

  form: FormGroup;
  readOnly: boolean;

  private saved &#x3D; false;
  private operation: Operation;
  private config: VotingSiteConfiguration;
  private subscriptions: Subscription[] &#x3D; [];


  constructor(private service: VotingSiteConfigurationService,
              private formBuilder: FormBuilder,
              private router: Router,
              private route: ActivatedRoute,
              private dictionaryService: DictionaryService,
              private readOnlyService: ReadOnlyService,
              private operationManagementService: OperationManagementService) {

  }

  get ready() {
    return !!this.config;
  }

  get allPossibleLanguages() {
    return [&#x27;DE&#x27;, &#x27;FR&#x27;, &#x27;IT&#x27;, &#x27;RM&#x27;];
  }

  isFormModified(): boolean {
    return isFormModifiedAndNotSaved(this.form, this.saved);
  }

  ngOnInit() {
    this.subscriptions.push(
      this.readOnlyService.isVotingSiteConfigurationInReadonly()
        .subscribe(readOnly &#x3D;&gt; {
          this.readOnly &#x3D; readOnly;
          this.updateForReadonly();
        }),
      this.operationManagementService.operation
        .pipe(
          tap(operation &#x3D;&gt; this.operation &#x3D; operation),
          flatMap(operation &#x3D;&gt;this.service.findForOperation(operation.id)),
          flatMap(config &#x3D;&gt; {
            if (!config) {
              return this.dictionaryService.getDefaultLang(this.operation.id)
                .pipe(map(defaultLanguage &#x3D;&gt; {
                  return {defaultLanguage: defaultLanguage, allLanguages: [defaultLanguage]}
                }))
            }
            return of(config)
          }),
          tap(config &#x3D;&gt; this.config &#x3D; config)
        )
        .subscribe(config &#x3D;&gt; {
          let controlConfig &#x3D; {
            defaultLanguage: [config.defaultLanguage, Validators.required],
          };
          this.allPossibleLanguages.forEach(lang &#x3D;&gt; {
            controlConfig[lang] &#x3D; [this.config.allLanguages.indexOf(lang) &gt;&#x3D; 0]
          });
          this.form &#x3D; this.formBuilder.group(controlConfig);
          this.updateForReadonly();
        })
    )
  }

  save() {
    this.form.controls.defaultLanguage.markAsTouched();
    this.form.updateValueAndValidity();

    if (this.form.valid) {
      let values &#x3D; this.form.getRawValue();
      let votingSiteConfiguration: VotingSiteConfiguration &#x3D; {
        defaultLanguage: values.defaultLanguage,
        allLanguages: this.allPossibleLanguages.filter(l &#x3D;&gt; values[l])
      };

      this.service.saveOrUpdate(this.operation.id, votingSiteConfiguration)
        .subscribe(() &#x3D;&gt; {
          this.operationManagementService.shouldUpdateStatus();
          this.saved &#x3D; true;
          this.router.navigate([&#x27;../..&#x27;], {relativeTo: this.route});
        });
    }
  }

  changeDefaultLang() {
    this.form.controls[this.form.controls.defaultLanguage.value].setValue(true);
    this.updateForReadonly();
  }

  private updateForReadonly() {
    if (this.form) {
      enableFormComponents(this.form.controls, !this.readOnly);
      enableFormComponent(this.form.controls[this.form.controls.defaultLanguage.value], false);
    }
  }

  ngOnDestroy(): void {
    this.subscriptions.forEach(s &#x3D;&gt; s.unsubscribe());
  }
}
</code></pre>
    </div>

    <div class="tab-pane fade " id="c-templateData">
        <pre class="line-numbers"><code class="language-html">&lt;mat-card id&#x3D;&quot;votingSiteConfigurationEdit&quot; [class.read-only]&#x3D;&quot;readOnly&quot; *ngIf&#x3D;&quot;ready&quot;&gt;
  &lt;mat-card-header&gt;
    &lt;mat-card-title&gt;{{&#x27;parameters.voting-site-configuration.edit.title&#x27; | translate}}&lt;/mat-card-title&gt;
    &lt;mat-card-subtitle fxLayout&#x3D;&quot;row&quot; fxLayoutAlign&#x3D;&quot;space-between&quot;&gt;
      &lt;span&gt;{{&#x27;parameters.voting-site-configuration.edit.subtitle&#x27; | translate}}&lt;/span&gt;
      &lt;span *ngIf&#x3D;&quot;!readOnly&quot;&gt;{{&#x27;global.forms.fields.required&#x27; | translate}}&lt;/span&gt;
    &lt;/mat-card-subtitle&gt;
  &lt;/mat-card-header&gt;

  &lt;mat-card-content&gt;
    &lt;ng-container&gt;

      &lt;form [formGroup]&#x3D;&quot;form&quot; novalidate&gt;

        &lt;h2&gt;{{&#x27;parameters.voting-site-configuration.default-languages&#x27;| translate}}&lt;/h2&gt;
        &lt;div fxLayout&#x3D;&quot;row wrap&quot; fxLayoutGap&#x3D;&quot;25px&quot;&gt;
          &lt;mat-form-field fxFlex&#x3D;&quot;50 0 200px&quot;&gt;
            &lt;mat-select formControlName&#x3D;&quot;defaultLanguage&quot; (selectionChange)&#x3D;&quot;changeDefaultLang()&quot;
                        placeholder&#x3D;&quot;{{&#x27;parameters.voting-site-configuration.edit.form.fields.default-language.placeholder&#x27; | translate}}&quot;&gt;
              &lt;mat-option *ngFor&#x3D;&quot;let lang of allPossibleLanguages&quot; [value]&#x3D;&quot;lang&quot;&gt;
                {{ &#x27;parameters.voting-site-configuration.language.&#x27; + lang | translate}}
              &lt;/mat-option&gt;
            &lt;/mat-select&gt;

            &lt;mat-error&gt;
              &lt;default-errors [fieldName]&#x3D;&quot;&#x27;defaultLanguage&#x27;&quot; [form]&#x3D;&quot;form&quot;&gt;&lt;/default-errors&gt;
            &lt;/mat-error&gt;

          &lt;/mat-form-field&gt;
        &lt;/div&gt;


        &lt;h2&gt;{{&#x27;parameters.voting-site-configuration.available-languages&#x27;| translate}}&lt;/h2&gt;
        &lt;div id&#x3D;&quot;site-languages&quot;&gt;
          &lt;div class&#x3D;&quot;site-language&quot; *ngFor&#x3D;&quot;let lang of allPossibleLanguages&quot;&gt;
            &lt;mat-checkbox formControlName&#x3D;&quot;{{lang}}&quot; color&#x3D;&quot;primary&quot; id&#x3D;&quot;{{&#x27;checkbox-&#x27; + lang}}&quot;&gt;
              {{ &#x27;parameters.voting-site-configuration.language.&#x27; + lang | translate}}
            &lt;/mat-checkbox&gt;
          &lt;/div&gt;
        &lt;/div&gt;
      &lt;/form&gt;

    &lt;/ng-container&gt;
  &lt;/mat-card-content&gt;
  &lt;mat-card-actions *ngIf&#x3D;&quot;!readOnly&quot;&gt;
    &lt;div fxLayout fxLayoutAlign&#x3D;&quot;end&quot;&gt;
      &lt;button mat-raised-button id&#x3D;&quot;saveButton&quot; color&#x3D;&quot;primary&quot;
              (click)&#x3D;&quot;save()&quot;&gt;{{&#x27;global.actions.save&#x27; | translate | uppercase}}
      &lt;/button&gt;
    &lt;/div&gt;
  &lt;/mat-card-actions&gt;
&lt;/mat-card&gt;
</code></pre>
    </div>

    <div class="tab-pane fade " id="c-styleData">
                <p class="comment">
                    <code>./voting-site-configuration.component.scss</code>
                </p>
                <pre class="line-numbers"><code class="language-scss">#site-languages {
  display: flex;
  justify-content: space-around;
}

.site-language {
  text-align: center;
}
</code></pre>
    </div>

    <div class="tab-pane fade " id="c-tree">
        <div id="tree-container"></div>
        <div class="tree-legend">
            <div class="title">
                <b>Legend</b>
            </div>
            <div>
                <div class="color htmlelement"></div><span>Html element</span>
            </div>
            <div>
                <div class="color component"></div><span>Component</span>
            </div>
            <div>
                <div class="color directive"></div><span>Html element with directive</span>
            </div>
        </div>
    </div>

    
</div>

<script src="../js/libs/vis.min.js"></script>
<script src="../js/libs/htmlparser.js"></script>
<script src="../js/libs/deep-iterator.js"></script>
<script>
        var COMPONENT_TEMPLATE = '<div><mat-card id="votingSiteConfigurationEdit" [class.read-only]="readOnly" *ngIf="ready">  <mat-card-header>    <mat-card-title>{{\'parameters.voting-site-configuration.edit.title\' | translate}}</mat-card-title>    <mat-card-subtitle fxLayout="row" fxLayoutAlign="space-between">      <span>{{\'parameters.voting-site-configuration.edit.subtitle\' | translate}}</span>      <span *ngIf="!readOnly">{{\'global.forms.fields.required\' | translate}}</span>    </mat-card-subtitle>  </mat-card-header>  <mat-card-content>    <ng-container>      <form [formGroup]="form" novalidate>        <h2>{{\'parameters.voting-site-configuration.default-languages\'| translate}}</h2>        <div fxLayout="row wrap" fxLayoutGap="25px">          <mat-form-field fxFlex="50 0 200px">            <mat-select formControlName="defaultLanguage" (selectionChange)="changeDefaultLang()"                        placeholder="{{\'parameters.voting-site-configuration.edit.form.fields.default-language.placeholder\' | translate}}">              <mat-option *ngFor="let lang of allPossibleLanguages" [value]="lang">                {{ \'parameters.voting-site-configuration.language.\' + lang | translate}}              </mat-option>            </mat-select>            <mat-error>              <default-errors [fieldName]="\'defaultLanguage\'" [form]="form"></default-errors>            </mat-error>          </mat-form-field>        </div>        <h2>{{\'parameters.voting-site-configuration.available-languages\'| translate}}</h2>        <div id="site-languages">          <div class="site-language" *ngFor="let lang of allPossibleLanguages">            <mat-checkbox formControlName="{{lang}}" color="primary" id="{{\'checkbox-\' + lang}}">              {{ \'parameters.voting-site-configuration.language.\' + lang | translate}}            </mat-checkbox>          </div>        </div>      </form>    </ng-container>  </mat-card-content>  <mat-card-actions *ngIf="!readOnly">    <div fxLayout fxLayoutAlign="end">      <button mat-raised-button id="saveButton" color="primary"              (click)="save()">{{\'global.actions.save\' | translate | uppercase}}      </button>    </div>  </mat-card-actions></mat-card></div>'
    var COMPONENTS = [{'name': 'ActionCardComponent', 'selector': 'action-card'},{'name': 'AdminCardsViewComponent', 'selector': 'admin-cards-view'},{'name': 'AdminComponent', 'selector': 'app-admin'},{'name': 'AdminEditViewComponent', 'selector': 'admin-edit-view'},{'name': 'AppComponent', 'selector': 'app-root'},{'name': 'BallotDocumentationCardComponent', 'selector': 'ballot-documentation-card'},{'name': 'BallotDocumentationEditComponent', 'selector': ''},{'name': 'BaseCardComponent', 'selector': 'base-card'},{'name': 'BaseCreateComponent', 'selector': ''},{'name': 'BaseEditComponent', 'selector': ''},{'name': 'BusinessErrorDialogComponent', 'selector': 'app-business-error-dialog'},{'name': 'CardTitleCardComponent', 'selector': 'card-title-card'},{'name': 'CardTitleEditComponent', 'selector': 'card-title-edit'},{'name': 'CompletableCardComponent', 'selector': 'completable-card'},{'name': 'DashboardComponent', 'selector': ''},{'name': 'DefaultErrorsComponent', 'selector': 'default-errors'},{'name': 'DeploymentSummaryComponent', 'selector': 'deployment-summary'},{'name': 'DocumentCardComponent', 'selector': 'document-card'},{'name': 'DocumentEditComponent', 'selector': ''},{'name': 'DomainInfluenceCardComponent', 'selector': 'domain-influence-card'},{'name': 'DomainInfluenceEditComponent', 'selector': ''},{'name': 'DomainInfluenceGridComponent', 'selector': 'domain-influence-grid'},{'name': 'EditContentComponent', 'selector': 'edit-content'},{'name': 'EditLabelComponent', 'selector': 'edit-label'},{'name': 'EditWithSideBarComponent', 'selector': 'edit-with-side-bar'},{'name': 'ElectionDetailsComponent', 'selector': 'election-details'},{'name': 'ElectionDetailsElectoralListComponent', 'selector': 'election-details-electoral-lists'},{'name': 'ElectionDetailsTableComponent', 'selector': 'election-details-table'},{'name': 'ElectionPagePropertiesCardComponent', 'selector': 'election-page-properties-card'},{'name': 'ElectionPagePropertiesEditComponent', 'selector': 'election-page-properties-edit'},{'name': 'ElectionPagePropertiesMappingComponent', 'selector': 'election-page-properties-mapping'},{'name': 'ElectionPagePropertiesModelEditComponent', 'selector': 'election-page-properties-model-edit'},{'name': 'ElectionPagePropertiesModelListComponent', 'selector': 'election-page-properties-model-list'},{'name': 'ElectoralAuthorityKeyCardComponent', 'selector': 'electoral-authority-key-card'},{'name': 'ElectoralAuthorityKeyListComponent', 'selector': 'electoral-authority-key-list'},{'name': 'GroupedGridComponent', 'selector': 'grouped-grid'},{'name': 'HeaderComponent', 'selector': 'chvote-header'},{'name': 'HighlightedQuestionEditComponent', 'selector': 'highlighted-question-edit'},{'name': 'HighlightedQuestionListComponent', 'selector': 'highlighted-question-list'},{'name': 'KeyViewComponent', 'selector': 'key-view'},{'name': 'LocalizedHighlightedQuestionListComponent', 'selector': 'localized-highlighted-question-list'},{'name': 'LoginComponent', 'selector': ''},{'name': 'ManagementEntityCardComponent', 'selector': 'management-entity-card'},{'name': 'ManagementEntityEditComponent', 'selector': 'management-entity-edit'},{'name': 'ManagementEntityListComponent', 'selector': 'management-entity-list'},{'name': 'ManagementEntitySelectorComponent', 'selector': 'management-entity-selector'},{'name': 'MilestoneCardComponent', 'selector': 'milestone-card'},{'name': 'MilestoneEditComponent', 'selector': ''},{'name': 'ModelSelectorComponent', 'selector': 'election-page-bulk-update'},{'name': 'OperationListComponent', 'selector': 'operation-list'},{'name': 'OperationManagementComponent', 'selector': ''},{'name': 'ParametersComponent', 'selector': 'parameters'},{'name': 'ParametersEditComponent', 'selector': ''},{'name': 'ParametersNotificationComponent', 'selector': 'parameters-notification'},{'name': 'PrinterCardComponent', 'selector': 'printer-card'},{'name': 'PrinterEditComponent', 'selector': 'printer-edit'},{'name': 'PrinterViewComponent', 'selector': 'printer-view'},{'name': 'ProductionSummaryComponent', 'selector': 'production-summary'},{'name': 'RegisterCardComponent', 'selector': 'register-card'},{'name': 'RegisterListComponent', 'selector': 'register-list'},{'name': 'RegisterUploadComponent', 'selector': 'register-upload'},{'name': 'RepositoryCardComponent', 'selector': 'repository-card'},{'name': 'RepositoryEditComponent', 'selector': ''},{'name': 'SelectedElectoralAuthorityKeyCardComponent', 'selector': 'selected-electoral-authority-key-card'},{'name': 'SelectedElectoralAuthorityKeyEditComponent', 'selector': 'selected-electoral-authority-key-edit'},{'name': 'SideBarBackButtonComponent', 'selector': 'side-bar-back-button'},{'name': 'SideBarItemComponent', 'selector': 'side-bar-item'},{'name': 'SlideDetailsComponent', 'selector': 'slide-details'},{'name': 'SlideDetailsContentComponent', 'selector': 'slide-details-content'},{'name': 'SlideDetailsDetailsComponent', 'selector': 'slide-details-details'},{'name': 'SmallProgressSpinnerComponent', 'selector': 'small-progress-spinner'},{'name': 'TallyComponent', 'selector': 'tally'},{'name': 'TechnicalErrorDialogComponent', 'selector': 'app-technical-error-dialog'},{'name': 'TestingCardsLotCardComponent', 'selector': 'testing-cards-lot-card'},{'name': 'TestingCardsLotDetailsComponent', 'selector': 'testing-cards-lot-details'},{'name': 'TestingCardsLotListComponent', 'selector': 'testing-cards-lot-list'},{'name': 'TestingCardsLotSideBarItemComponent', 'selector': 'testing-cards-lot-side-bar-item'},{'name': 'TestSiteCardsDownloadButtonComponent', 'selector': 'test-site-cards-download-button'},{'name': 'TestSummaryComponent', 'selector': 'test-summary'},{'name': 'TextWithEditComponent', 'selector': 'text-with-edit'},{'name': 'UploadInputComponent', 'selector': 'upload-input'},{'name': 'VerificationCodeEditComponent', 'selector': 'verification-code-edit'},{'name': 'VotationDetailsComponent', 'selector': 'votation-details'},{'name': 'VotingMaterialComponent', 'selector': ''},{'name': 'VotingMaterialCreationProgressComponent', 'selector': 'voting-material-creation-progress'},{'name': 'VotingMaterialNotificationComponent', 'selector': 'voting-material-notification'},{'name': 'VotingPeriodComponent', 'selector': ''},{'name': 'VotingPeriodNotificationComponent', 'selector': 'voting-period-notification'},{'name': 'VotingSiteConfigurationCardComponent', 'selector': 'voting-site-configuration-card'},{'name': 'VotingSiteConfigurationComponent', 'selector': 'voting-site-configuration-edit'},{'name': 'VotingSitePeriodCardComponent', 'selector': 'voting-site-period-card'},{'name': 'VotingSitePeriodEditComponent', 'selector': 'voting-site-period-edit'},{'name': 'WaitingCover', 'selector': ''}];
    var DIRECTIVES = [{'name': 'CheckRolesDirective', 'selector': '[roles]'}];
    var ACTUAL_COMPONENT = {'name': 'VotingSiteConfigurationComponent'};
</script>
<script src="../js/tree.js"></script>














                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'component';
            var COMPODOC_CURRENT_PAGE_URL = 'VotingSiteConfigurationComponent.html';
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
